import React, { useMemo } from 'react';
import classnames from 'classnames';
import uniqueId from 'lodash/uniqueId';
import { parseMetadata } from '@highlight-ui/utils-commons';
import Typography from '@highlight-ui/typography';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "@charset \"UTF-8\";\n@import url(\"https://fonts.googleapis.com/css2?family=IBM+Plex+Mono:wght@400;700&display=swap\");\n@import url(\"https://fonts.googleapis.com/css2?family=Open+Sans:ital,wght@0,300;0,400;0,600;0,700;1,300;1,400;1,600;1,700&display=swap\");\n.Checkbox-module__1j6zQ7de__v1-0-1 {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.Checkbox-module__1kgWLr7T__v1-0-1 {\n  display: inline-flex;\n  flex-direction: column;\n  max-width: 100%;\n  position: relative;\n}\n\n.Checkbox-module__2qeuuhJu__v1-0-1 {\n  align-self: flex-start;\n  cursor: pointer;\n  max-width: 100%;\n  min-height: 20px;\n  padding-left: 14px;\n  position: relative;\n  /*\n    TODO: Replace pseudo-elements in Checkbox\n    See: https://personio.atlassian.net/browse/PPU-701\n  */\n}\n.Checkbox-module__2qeuuhJu__v1-0-1::before {\n  border: solid 1px #a5a5a5;\n  border-radius: 2px;\n  content: \"\";\n  height: 14px;\n  left: 0;\n  position: absolute;\n  top: 50%;\n  transform: translateY(-50%);\n  transition: all ease-in-out 0.2s;\n  width: 14px;\n}\n.Checkbox-module__2qeuuhJu__v1-0-1:hover::before {\n  border-color: #555;\n}\n.Checkbox-module__2qeuuhJu__v1-0-1::after {\n  color: #fff;\n  content: \"\";\n  display: none;\n  font-family: \"Font Awesome 5 Pro\";\n  font-size: 8px;\n  font-weight: 600;\n  left: 3px;\n  line-height: 8px;\n  position: absolute;\n  top: 50%;\n  transform: translateY(-50%);\n}\n\n.Checkbox-module__1j6zQ7de__v1-0-1 {\n  float: left;\n  margin-left: 8px;\n  max-width: 100%;\n}\n\n.Checkbox-module__GJgD8tzu__v1-0-1 {\n  color: #a5a5a5;\n  display: inline-block;\n  max-width: 100%;\n  padding-left: 22px;\n}\n\n.Checkbox-module__2xgL7bHv__v1-0-1 {\n  clip: rect(0, 0, 0, 0);\n  height: 1px;\n  left: 0;\n  opacity: 0;\n  overflow: hidden;\n  position: absolute;\n  top: 0;\n  width: 1px;\n}\n\n.Checkbox-module__2xgL7bHv__v1-0-1:focus + .Checkbox-module__2qeuuhJu__v1-0-1::before {\n  box-shadow: 0 0 0 2px #cff0f9;\n}\n\n.Checkbox-module__2xgL7bHv__v1-0-1:checked + .Checkbox-module__2qeuuhJu__v1-0-1::before {\n  background-color: #0db5df;\n  border-color: #0db5df;\n}\n.Checkbox-module__2xgL7bHv__v1-0-1:checked + .Checkbox-module__2qeuuhJu__v1-0-1::after {\n  display: block;\n}\n\n.Checkbox-module__2xgL7bHv__v1-0-1:disabled + .Checkbox-module__2qeuuhJu__v1-0-1 {\n  color: #d6d6d6;\n  cursor: not-allowed;\n}\n.Checkbox-module__2xgL7bHv__v1-0-1:disabled + .Checkbox-module__2qeuuhJu__v1-0-1::before {\n  background-color: #f7f7f7;\n  border-color: #d6d6d6;\n}\n.Checkbox-module__2xgL7bHv__v1-0-1:disabled ~ .Checkbox-module__GJgD8tzu__v1-0-1 {\n  color: #d6d6d6;\n  cursor: not-allowed;\n}\n.Checkbox-module__2xgL7bHv__v1-0-1:disabled:checked + .Checkbox-module__2qeuuhJu__v1-0-1::before {\n  background-color: #d6d6d6;\n}";
var styles = {"checkboxLabelText":"Checkbox-module__1j6zQ7de__v1-0-1","checkbox":"Checkbox-module__1kgWLr7T__v1-0-1","checkboxLabel":"Checkbox-module__2qeuuhJu__v1-0-1","checkboxSubLabel":"Checkbox-module__GJgD8tzu__v1-0-1","checkboxInput":"Checkbox-module__2xgL7bHv__v1-0-1"};
styleInject(css_248z);

// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
var CheckboxWithRef = function (_a, ref) {
    var label = _a.label, subLabel = _a.subLabel, className = _a.className, metadata = _a.metadata, id = _a.id, checkboxProps = __rest(_a, ["label", "subLabel", "className", "metadata", "id"]);
    var generatedId = useMemo(function () { return uniqueId('checkbox-'); }, []);
    var inputId = id || generatedId;
    return (React.createElement("span", __assign({ className: classnames(className, styles.checkbox) }, parseMetadata(metadata)),
        React.createElement("input", __assign({ ref: ref, id: inputId, type: "checkbox", className: styles.checkboxInput }, checkboxProps)),
        React.createElement("label", { htmlFor: inputId, className: styles.checkboxLabel }, label && (React.createElement(Typography, { title: label, variant: "body-1", component: "span", className: styles.checkboxLabelText }, label))),
        label && subLabel && (React.createElement(Typography, { title: subLabel, variant: "body-1", component: "span", className: styles.checkboxSubLabel }, subLabel))));
};
CheckboxWithRef.displayName = 'Checkbox';
var Checkbox = React.forwardRef(CheckboxWithRef);

export default Checkbox;
//# sourceMappingURL=index.js.map
